//
//  WBO3ViewController.m
//  MicroLifeDeviceSDK-Dome
//
//  Created by willy.wu on 2019/11/1.
//  Copyright © 2019 WiFi@MBP. All rights reserved.
//

#import "WBO3ViewController.h"

@interface WBO3ViewController () <WBO3DataResponseDelegate> {
    Dformat dformat;
    MicroLifeSettingValues *aSettingValues;
}
@property (strong, nonatomic) WBO3BLEManager *aWBO3BLEManager;
@property (assign, nonatomic) int SWCBPindexMax;

@property (weak, nonatomic) IBOutlet UITextField *editUserID;
@property (weak, nonatomic) IBOutlet UITextField *editCBPindex;
@property (weak, nonatomic) IBOutlet UITextField *editABPMStart;
@property (weak, nonatomic) IBOutlet UITextField *editABPMEnd;
@property (weak, nonatomic) IBOutlet UITextField *editABPMInt_first;
@property (weak, nonatomic) IBOutlet UITextField *editABPMInt_second;
@property (weak, nonatomic) IBOutlet UITextField *editHI_infPressure;
@property (weak, nonatomic) IBOutlet UISwitch *SW_checkhide;
@property (weak, nonatomic) IBOutlet UISwitch *SW_SEL_silent;
@property (weak, nonatomic) IBOutlet UISwitch *SW_CBP_zone1_meas_off;
@property (weak, nonatomic) IBOutlet UISwitch *SW_CBP_zone2_meas_off;
@property (weak, nonatomic) IBOutlet UITextField *editCBPInt_first;
@property (weak, nonatomic) IBOutlet UITextField *editCBPInt_second;

@end

@implementation WBO3ViewController

- (void)viewDidLoad {
    [super viewDidLoad];
    // Do any additional setup after loading the view.
    self.aWBO3BLEManager = [WBO3BLEManager shareInstanceWhithAuthorizationkey:SDKkey_WBP];
    self.aWBO3BLEManager.dataResponseDelegate = self;
    
    self.wbo3BindingDevice = [self.aWBO3BLEManager getBindingDevice];
    
}

- (void)viewWillAppear:(BOOL)animated {
    [super viewWillAppear:animated];
    [self addLogWhitText:@"WBO3BLEManager Start"];
    NSString *log = [NSString stringWithFormat:@"WBO3BLEManager bpmBindingDevice:%@",self.wboBindingDevice];
    [self addLogWhitText:log];
    [self bindingDeviceWhitMacAddres:self.wboBindingDevice];
}

- (void)viewWillDisappear:(BOOL)animated {
    [super viewWillDisappear:animated];
    // Disconnect Device
    [self.aWBO3BLEManager disconnectDevice];
}

- (void)viewDidLayoutSubviews {
    self.butView.contentSize = CGSizeMake(self.butView.frame.size.width, self.butView.frame.size.height*2);
}

#pragma mark - settingValues
- (void)setSV {
    self.editABPMStart.text = [NSString stringWithFormat:@"%d",aSettingValues.ABPMStart];
    self.editABPMEnd.text = [NSString stringWithFormat:@"%d",aSettingValues.ABPMEnd];
    self.editABPMInt_first.text = [NSString stringWithFormat:@"%d",aSettingValues.ABPMInt_first];
    self.editABPMInt_second.text = [NSString stringWithFormat:@"%d",aSettingValues.ABPMInt_second];
    self.editHI_infPressure.text = [NSString stringWithFormat:@"%d",aSettingValues.HI_infPressure];
    self.SW_checkhide.on = aSettingValues.SW_checkhide;
    self.SW_SEL_silent.on = aSettingValues.SW_SEL_silent;
    self.SW_CBP_zone1_meas_off.on = aSettingValues.CBP_zone1_meas_off;
    self.SW_CBP_zone2_meas_off.on = aSettingValues.CBP_zone2_meas_off;
    self.editCBPInt_first.text = [NSString stringWithFormat:@"%d",aSettingValues.CBPInt_first];
    self.editCBPInt_second.text = [NSString stringWithFormat:@"%d",aSettingValues.CBPInt_second];
}

- (void)editSV {
    aSettingValues.ABPMStart = self.editABPMStart.text.intValue;
    aSettingValues.ABPMEnd = self.editABPMEnd.text.intValue;
    aSettingValues.ABPMInt_first = self.editABPMInt_first.text.intValue;
    aSettingValues.ABPMInt_second = self.editABPMInt_second.text.intValue;
    aSettingValues.HI_infPressure = self.editHI_infPressure.text.intValue;
    aSettingValues.SW_checkhide = self.SW_checkhide.on;
    aSettingValues.SW_SEL_silent = self.SW_SEL_silent.on;
    aSettingValues.CBP_zone1_meas_off = self.SW_CBP_zone1_meas_off.on;
    aSettingValues.CBP_zone2_meas_off = self.SW_CBP_zone2_meas_off.on;
    aSettingValues.CBPInt_first = self.editCBPInt_first.text.intValue;
    aSettingValues.CBPInt_second = self.editCBPInt_second.text.intValue;
}

#pragma mark - selected info
- (IBAction)editCBPRaw:(UISegmentedControl *)sender {
    NSString *format = @"No CBP Raw";
    switch (sender.selectedSegmentIndex) {
        case 0:
            format = @"No CBP Raw";
            dformat = MicroLifeDNoCBPRaw;
            break;
        case 1:
            format = @"Low CBP Raw";
            dformat = MicroLifeDLowCBPRaw;
            break;
        case 2:
            format = @"Full CBP Raw";
            dformat = MicroLifeDFullCBPRaw;
            break;
        default:
            break;
    }
    NSString *log = [NSString stringWithFormat:@"WBO3BLEManager selectedCBPRaw:%@",format];
    [self addLogWhitText:log];
}
- (IBAction)editSettingValues:(UISwitch *)sender {
    NSString *log = [NSString stringWithFormat:@"WBO3BLEManager editSettingValues:"];
    switch ([sender tag]) {
        case 200:
            aSettingValues.SW_checkhide = sender.on;
            log = [log stringByAppendingFormat:@"SW_checkhide"];
            break;
        case 201:
            aSettingValues.SW_SEL_silent = sender.on;
            log = [log stringByAppendingFormat:@"SW_SEL_silent"];
            break;
        case 202:
            aSettingValues.CBP_zone1_meas_off = sender.on;
            log = [log stringByAppendingFormat:@"CBP_zone1_meas_off"];
            break;
        case 203:
            aSettingValues.CBP_zone2_meas_off = sender.on;
            log = [log stringByAppendingFormat:@"CBP_zone2_meas_off"];
            break;
        default:
            break;
    }
    log = [log stringByAppendingFormat:@" %@",sender.on?@"YES":@"NO"];
    [self addLogWhitText:log];
}

#pragma mark - IBAction
- (IBAction)getBindingDevice:(id)sender {
    NSString *log = [NSString stringWithFormat:@"WBO3BLEManager getBindingDevice:%@",[self.aWBO3BLEManager getBindingDevice]];
    [self addLogWhitText:log];
}
- (IBAction)bindingDevice:(id)sender {
    [self.aWBO3BLEManager bindingDevice:self.wbo3BindingDevice];
    NSString *log = [NSString stringWithFormat:@"WBO3BLEManager bindingDevice:%@",self.wbo3BindingDevice];
    [self addLogWhitText:log];
    [self bindingDeviceWhitMacAddres:self.wboBindingDevice];
}
- (IBAction)unBindingDevice:(id)sender {
    [self.aWBO3BLEManager unBindingDevice];
    NSString *log = [NSString stringWithFormat:@"WBO3BLEManager unBindingDevice:%@",[self.aWBO3BLEManager getBindingDevice]];
    [self addLogWhitText:log];
}
- (IBAction)reScan:(id)sender {
    [self.aWBO3BLEManager reScan];
    [self addLogWhitText:@"WBO3BLEManager reScan"];
}
- (IBAction)stopScan:(id)sender {
    [self.aWBO3BLEManager stopScan];
    [self addLogWhitText:@"WBO3BLEManager stopScan"];
}
- (IBAction)disconnectDevice:(id)sender {
    [self.aWBO3BLEManager disconnectDevice];
    [self addLogWhitText:@"WBO3BLEManager disconnectDevice"];
}
- (IBAction)comAction:(UIButton *)sender {
    NSString *log = [NSString stringWithFormat:@"WBO3BLEManager  %@",sender.titleLabel.text];
    switch ([sender tag]) {
        case 100:
            [self.aWBO3BLEManager readAllHistorys];
            break;
        case 101:
            if (self.SWCBPindexMax > 0) {
                if (self.SWCBPindexMax >= self.editCBPindex.text.intValue && self.editCBPindex.text.intValue > 0) {
                    [self.aWBO3BLEManager readCBPDataWithIndex:self.editCBPindex.text.intValue Dformat:dformat];
                } else {
                    log = [log stringByAppendingFormat:@"\nThe number of errors is optional."];
                }
            }
            else {
                log = [log stringByAppendingFormat:@"\nPlease read all history data first!"];
            }
            break;
        case 103:
            [self.aWBO3BLEManager clearAllHistorys];
            break;
        case 104:
            [self.aWBO3BLEManager disconnect];
            break;
        case 105:
            [self.aWBO3BLEManager readUserAndVersionData];
            break;
        case 106:
            [self.aWBO3BLEManager writeUserID:self.editUserID.text];
            break;
        case 107:
            [self.aWBO3BLEManager readSettingValues];
            break;
        case 108:
            [self editSV];
            [self.aWBO3BLEManager writeSettingValues:aSettingValues];
            break;
        case 111:
            [self.aWBO3BLEManager readDeviceIDAndInfo];
            break;
        case 112:
            [self.aWBO3BLEManager readDeviceTime];
            break;
        case 113:
            [self.aWBO3BLEManager writeDeviceTime];
            break;
        case 116:
            [self.aWBO3BLEManager readFunctionSettingValue];
            break;
        case 119:
            [self.aWBO3BLEManager readBTModuleName];
            break;
        default:
            break;
    }
    [self addLogWhitText:log];
    [self addLogWhitText:self.aWBO3BLEManager.result];
}

#pragma mark - WBO3DataResponseDelegate
- (void)WBO3BLEManagerCellPhoneBluetoothDidUpdateState:(MicroLifeBLEState)state {
    if (state == MicroLifeBLEStatePoweredOn) {
        [self addLogWhitText:@"WBO3BLEManagerCellPhoneBluetoothDidUpdateState:MicroLifeBLEStatePoweredOn"];
    }else {
        [self addLogWhitText:@"WBO3BLEManagerCellPhoneBluetoothDidUpdateState:MicroLifeBLEStatePoweredOff"];
    }
}

- (void)WBO3BLEManagerDidConnectDevice {
    NSString *log = [NSString stringWithFormat:@"WBO3BLEManagerDidConnectDevice:%@",self.aWBO3BLEManager.bindingDevice.dictionaryFromModel];
    [self bindingDeviceWhitMacAddres:self.aWBO3BLEManager.bindingDevice.macAddress];
    [self addLogWhitText:log];
}

- (void)WBO3BLEManagerDidDisconnectDevice {
    [self addLogWhitText:@"WBO3LEManagerDidDisconnectDevice"];
    [self.aWBO3BLEManager reScan];
}

- (void)WBO3BLEManagerDidDiscoverBluetoothDeviceMacAddress:(nonnull NSData *)macAddress Name:(nonnull NSString *)name RSSI:(nonnull NSNumber *)RSSI {
    self.wbo3BindingDevice = macAddress;
    [self bindingDeviceWhitMacAddres:self.wbo3BindingDevice];
    NSString *log = [NSString stringWithFormat:@"WBO3BLEManagerDidDiscoverBluetoothDeviceMacAddress:%@ Name:%@",macAddress,name];
    [self addLogWhitText:log];
}

- (void)WBO3BLEManagerDidFailToConnectDevice {
    [self addLogWhitText:@"WBO3BLEManagerDidFailToConnectDevice"];
}

- (void)WBO3BLEManagerResponseClearHistory:(BOOL)isSuccess {
    NSString *log = [NSString stringWithFormat:@"WBO3BLEManagerResponseClearHistory:%@",isSuccess?@"YES":@"NO"];
    [self addLogWhitText:log];
    [self addLogWhitText:self.aWBO3BLEManager.message];
}

- (void)WBO3BLEManagerResponseReadAllHistorys:(nonnull MicroLifeDRecord *)data {
    NSString *log = [NSString stringWithFormat:@"WBO3BLEManagerResponseReadAllHistorys:%@",data.dictionaryFromModel];
    self.SWCBPindexMax = (int)data.MData.count;
    self.editCBPindex.text = [NSString stringWithFormat:@"%d",self.SWCBPindexMax];
    [self addLogWhitText:log];
    [self addLogWhitText:self.aWBO3BLEManager.message];
}

- (void)WBO3BLEManagerResponseReadBTModuleName:(nonnull NSString *)BTModuleName {
    NSString *log = [NSString stringWithFormat:@"WBO3BLEManagerResponseReadBTModuleName:%@",BTModuleName];
    [self addLogWhitText:log];
    [self addLogWhitText:self.aWBO3BLEManager.message];
}

- (void)WBO3BLEManagerResponseReadCBPData:(nonnull MicroLifeCBPdataAndCalCBP *)data IsNoData:(BOOL)isNoData {
    NSString *log = [NSString stringWithFormat:@"WBO3BLEManagerResponseReadCBPData:%@",isNoData?@"No Data":data.dictionaryFromModel];
    [self addLogWhitText:log];
    [self addLogWhitText:self.aWBO3BLEManager.message];
}

- (void)WBO3BLEManagerResponseReadDeviceTime:(nonnull MicroLifeDeviceInfo *)deviceInfo {
    NSString *log = [NSString stringWithFormat:@"WBO3BLEManagerResponseReadDeviceTime:%@",deviceInfo.dictionaryFromModel];
    [self addLogWhitText:log];
    [self addLogWhitText:self.aWBO3BLEManager.message];
}

- (void)WBO3BLEManagerResponseReadFunctionSettingValue:(nonnull MicroLifeFunctionSettingValues *)functionSettingValues {
    NSString *log = [NSString stringWithFormat:@"WBO3BLEManagerResponseReadFunctionSettingValue:%@",functionSettingValues.dictionaryFromModel];
    [self addLogWhitText:log];
    [self addLogWhitText:self.aWBO3BLEManager.message];
}

- (void)WBO3BLEManagerResponseReadSettingValue:(nonnull MicroLifeSettingValues *)settingValues {
    NSString *log = [NSString stringWithFormat:@"WBO3BLEManagerResponseReadSettingValue:%@",settingValues.dictionaryFromModel];
    [self addLogWhitText:log];
    [self addLogWhitText:self.aWBO3BLEManager.message];
    aSettingValues = settingValues;
    [self setSV];
}

- (void)WBO3BLEManagerResponseReadUserAndVersionData:(nonnull MicroLifeUserInfo *)user VersionData:(nonnull MicroLifeDeviceInfo *)verData {
    NSString *log = [NSString stringWithFormat:@"WBO3BLEManagerResponseReadUserAndVersionData:%@ VersionData:%@",user.dictionaryFromModel,verData.dictionaryFromModel];
    self.editUserID.text = user.BPMuserID;
    [self addLogWhitText:log];
    [self addLogWhitText:self.aWBO3BLEManager.message];
}

- (void)WBO3BLEManagerResponseWriteDeviceTime:(BOOL)isSuccess {
    NSString *log = [NSString stringWithFormat:@"WBO3BLEManagerResponseWriteDeviceTime:%@",isSuccess?@"YES":@"NO"];
    [self addLogWhitText:log];
    [self addLogWhitText:self.aWBO3BLEManager.message];
}

- (void)WBO3BLEManagerResponseWriteSettingValues:(BOOL)isSuccess {
    NSString *log = [NSString stringWithFormat:@"WBO3BLEManagerResponseWriteSettingValues:%@",isSuccess?@"YES":@"NO"];
    [self addLogWhitText:log];
    [self addLogWhitText:self.aWBO3BLEManager.message];
}

- (void)WBO3BLEManagerResponseWriteUserID:(BOOL)isSuccess {
    NSString *log = [NSString stringWithFormat:@"WBO3BLEManagerResponseWriteUserID:%@",isSuccess?@"YES":@"NO"];
    [self addLogWhitText:log];
    [self addLogWhitText:self.aWBO3BLEManager.message];
}

- (void)WBO3BLEManagerResponseReadDeviceIDAndInfo:(nonnull MicroLifeDeviceInfo *)deviceInfo {
    NSString *log = [NSString stringWithFormat:@"WBO3BLEManagerResponseReadDeviceIDAndInfo:%@",deviceInfo.dictionaryFromModel];
    [self addLogWhitText:log];
    [self addLogWhitText:self.aWBO3BLEManager.message];
}


@end
